Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class ConcurrentSkipListSet

    java.lang.Object
      java.util.AbstractCollection
          java.util.AbstractSet
              edu.emory.mathcs.backport.java.util.AbstractSet
                  edu.emory.mathcs.backport.java.util.concurrent.ConcurrentSkipListSet

All Implemented Interfaces:
  java.lang.Cloneable, java.util.Collection, NavigableSet, java.io.Serializable, java.util.Set, java.util.SortedSet

public class ConcurrentSkipListSet
extends AbstractSet
implements NavigableSet, java.lang.Cloneable, java.io.Serializable

A scalable concurrent `NavigableSet` implementation based on a `ConcurrentSkipListMap`. The elements of the set are kept sorted according to their natural ordering, or by a `Comparator` provided at set creation time, depending on which constructor is used.

This implementation provides expected average log(n) time cost for the `contains`, `add`, and `remove` operations and their variants. Insertion, removal, and access operations safely execute concurrently by multiple threads. Iterators are weakly consistent, returning elements reflecting the state of the set at some point at or since the creation of the iterator. They do not throw `ConcurrentModificationException`, and may proceed concurrently with other operations. Ascending ordered views and their iterators are faster than descending ones.

Beware that, unlike in most collections, the `size` method is not a constant-time operation. Because of the asynchronous nature of these sets, determining the current number of elements requires a traversal of the elements. Additionally, the bulk operations `addAll`, `removeAll`, `retainAll`, and `containsAll` are not guaranteed to be performed atomically. For example, an iterator operating concurrently with an `addAll` operation might view only some of the added elements.

This class and its iterators implement all of the optional methods of the `Set` and `Iterator` interfaces. Like most other concurrent collection implementations, this class does not permit the use of `null` elements, because `null` arguments and return values cannot be reliably distinguished from the absence of elements.

This class is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Doug Lea
See Also:
  Serialized Form

Constructor Summary
`ConcurrentSkipListSet()` Constructs a new, empty set that orders its elements according to their natural ordering.
`ConcurrentSkipListSet(java.util.Collection c)` Constructs a new set containing the elements in the specified collection, that orders its elements according to their natural ordering.
`ConcurrentSkipListSet(java.util.Comparator comparator)` Constructs a new, empty set that orders its elements according to the specified comparator.
`ConcurrentSkipListSet(java.util.SortedSet s)` Constructs a new set containing the same elements and using the same ordering as the specified sorted set.

Method Summary
`boolean` | `add(java.lang.Object e)` Adds the specified element to this set if it is not already present.
`java.lang.Object` | `ceiling(java.lang.Object e)` Returns the least element in this set greater than or equal to the given element, or if there is no such element.
`void` | `clear()` Removes all of the elements from this set.
`java.lang.Object` | `clone()` Returns a shallow copy of this `ConcurrentSkipListSet` instance.
`java.util.Comparator` | `comparator()`
`boolean` | `contains(java.lang.Object o)` Returns `true` if this set contains the specified element.
`java.util.Iterator` | `descendingIterator()` Returns an iterator over the elements in this set in descending order.
`NavigableSet` | `descendingSet()` Returns a reverse order view of the elements contained in this set.
`boolean` | `equals(java.lang.Object o)` Compares the specified object with this set for equality.
`java.lang.Object` | `first()`
`java.lang.Object` | `floor(java.lang.Object e)` Returns the greatest element in this set less than or equal to the given element, or if there is no such element.
`java.util.SortedSet` | `headSet(java.lang.Object toElement)` Equivalent to .
`NavigableSet` | `headSet(java.lang.Object toElement, boolean inclusive)` Returns a view of the portion of this set whose elements are less than (or equal to, if is true) .
`java.lang.Object` | `higher(java.lang.Object e)` Returns the least element in this set strictly greater than the given element, or if there is no such element.
`boolean` | `isEmpty()` Returns `true` if this set contains no elements.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this set in ascending order.
`java.lang.Object` | `last()`
`java.lang.Object` | `lower(java.lang.Object e)` Returns the greatest element in this set strictly less than the given element, or if there is no such element.
`java.lang.Object` | `pollFirst()` Retrieves and removes the first (lowest) element, or returns if this set is empty.
`java.lang.Object` | `pollLast()` Retrieves and removes the last (highest) element, or returns if this set is empty.
`boolean` | `remove(java.lang.Object o)` Removes the specified element from this set if it is present.
`boolean` | `removeAll(java.util.Collection c)` Removes from this set all of its elements that are contained in the specified collection.
`int` | `size()` Returns the number of elements in this set.
`NavigableSet` | `subSet(java.lang.Object fromElement, boolean fromInclusive, java.lang.Object toElement, boolean toInclusive)` Returns a view of the portion of this set whose elements range from to .
`java.util.SortedSet` | `subSet(java.lang.Object fromElement, java.lang.Object toElement)` Equivalent to .
`java.util.SortedSet` | `tailSet(java.lang.Object fromElement)` Equivalent to .
`NavigableSet` | `tailSet(java.lang.Object fromElement, boolean inclusive)` Returns a view of the portion of this set whose elements are greater than (or equal to, if is true) .

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractSet
`toArray, toArray`

Methods inherited from class java.util.AbstractSet
`hashCode`

Methods inherited from class java.util.AbstractCollection
`addAll, containsAll, retainAll, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`addAll, containsAll, hashCode, retainAll, toArray, toArray`

Constructor Detail

### ConcurrentSkipListSet

    public ConcurrentSkipListSet()

  Constructs a new, empty set that orders its elements according to their natural ordering.

### ConcurrentSkipListSet

    public ConcurrentSkipListSet(java.util.Comparator comparator)

  Constructs a new, empty set that orders its elements according to the specified comparator.

Parameters:
  `comparator` - the comparator that will be used to order this set. If `null`, the natural ordering of the elements will be used.

### ConcurrentSkipListSet

    public ConcurrentSkipListSet(java.util.Collection c)

  Constructs a new set containing the elements in the specified collection, that orders its elements according to their natural ordering.

Parameters:
  `c` - The elements that will comprise the new set
Throws:
  `java.lang.ClassCastException` - if the elements in `c` are not `Comparable`, or are not mutually comparable
  `java.lang.NullPointerException` - if the specified collection or any of its elements are null

### ConcurrentSkipListSet

    public ConcurrentSkipListSet(java.util.SortedSet s)

  Constructs a new set containing the same elements and using the same ordering as the specified sorted set.

Parameters:
  `s` - sorted set whose elements will comprise the new set
Throws:
  `java.lang.NullPointerException` - if the specified sorted set or any of its elements are null

Method Detail

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this `ConcurrentSkipListSet` instance. (The elements themselves are not cloned.)

  Returns:
    a shallow copy of this set

### size

    public int size()

  Returns the number of elements in this set. If this set contains more than `Integer.MAX_VALUE` elements, it returns `Integer.MAX_VALUE`.

  Beware that, unlike in most collections, this method is NOT a constant-time operation. Because of the asynchronous nature of these sets, determining the current number of elements requires traversing them all to count them. Additionally, it is possible for the size to change during execution of this method, in which case the returned result will be inaccurate. Thus, this method is typically not very useful in concurrent applications.

  Specified by:
    `size` in interface `java.util.Set`
  Returns:
    the number of elements in this set

### isEmpty

    public boolean isEmpty()

  Returns `true` if this set contains no elements.

  Specified by:
    `isEmpty` in interface `java.util.Set`
  Returns:
    `true` if this set contains no elements

### contains

    public boolean contains(java.lang.Object o)

  Returns `true` if this set contains the specified element. More formally, returns `true` if and only if this set contains an element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `java.util.Set`
  Parameters:
    `o` - object to be checked for containment in this set
  Returns:
    `true` if this set contains the specified element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in this set
    `java.lang.NullPointerException` - if the specified element is null

### add

    public boolean add(java.lang.Object e)

  Adds the specified element to this set if it is not already present. More formally, adds the specified element `e` to this set if the set contains no element `e2` such that `e.equals(e2)`. If this set already contains the element, the call leaves the set unchanged and returns `false`.

  Specified by:
    `add` in interface `java.util.Set`
  Parameters:
    `e` - element to be added to this set
  Returns:
    `true` if this set did not already contain the specified element
  Throws:
    `java.lang.ClassCastException` - if `e` cannot be compared with the elements currently in this set
    `java.lang.NullPointerException` - if the specified element is null

### remove

    public boolean remove(java.lang.Object o)

  Removes the specified element from this set if it is present. More formally, removes an element `e` such that `o.equals(e)`, if this set contains such an element. Returns `true` if this set contained the element (or equivalently, if this set changed as a result of the call). (This set will not contain the element once the call returns.)

  Specified by:
    `remove` in interface `java.util.Set`
  Parameters:
    `o` - object to be removed from this set, if present
  Returns:
    `true` if this set contained the specified element
  Throws:
    `java.lang.ClassCastException` - if `o` cannot be compared with the elements currently in this set
    `java.lang.NullPointerException` - if the specified element is null

### clear

    public void clear()

  Removes all of the elements from this set.

  Specified by:
    `clear` in interface `java.util.Set`

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this set in ascending order.

  Specified by:
    `iterator` in interface `NavigableSet`
  Returns:
    an iterator over the elements in this set in ascending order

### descendingIterator

    public java.util.Iterator descendingIterator()

  Returns an iterator over the elements in this set in descending order.

  Specified by:
    `descendingIterator` in interface `NavigableSet`
  Returns:
    an iterator over the elements in this set in descending order

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified object with this set for equality. Returns `true` if the specified object is also a set, the two sets have the same size, and every member of the specified set is contained in this set (or equivalently, every member of this set is contained in the specified set). This definition ensures that the equals method works properly across different implementations of the set interface.

  Specified by:
    `equals` in interface `java.util.Set`
  Parameters:
    `o` - the object to be compared for equality with this set
  Returns:
    `true` if the specified object is equal to this set

### removeAll

    public boolean removeAll(java.util.Collection c)

  Removes from this set all of its elements that are contained in the specified collection. If the specified collection is also a set, this operation effectively modifies this set so that its value is the asymmetric set difference of the two sets.

  Specified by:
    `removeAll` in interface `java.util.Set`
  Parameters:
    `c` - collection containing elements to be removed from this set
  Returns:
    `true` if this set changed as a result of the call
  Throws:
    `java.lang.ClassCastException` - if the types of one or more elements in this set are incompatible with the specified collection
    `java.lang.NullPointerException` - if the specified collection or any of its elements are null

### lower

    public java.lang.Object lower(java.lang.Object e)

  Description copied from interface: `NavigableSet`
  Returns the greatest element in this set strictly less than the given element, or if there is no such element.

  Specified by:
    `lower` in interface `NavigableSet`
  Parameters:
    `e` - the value to match
  Returns:
    the greatest element less than , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null

### floor

    public java.lang.Object floor(java.lang.Object e)

  Description copied from interface: `NavigableSet`
  Returns the greatest element in this set less than or equal to the given element, or if there is no such element.

  Specified by:
    `floor` in interface `NavigableSet`
  Parameters:
    `e` - the value to match
  Returns:
    the greatest element less than or equal to , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null

### ceiling

    public java.lang.Object ceiling(java.lang.Object e)

  Description copied from interface: `NavigableSet`
  Returns the least element in this set greater than or equal to the given element, or if there is no such element.

  Specified by:
    `ceiling` in interface `NavigableSet`
  Parameters:
    `e` - the value to match
  Returns:
    the least element greater than or equal to , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null

### higher

    public java.lang.Object higher(java.lang.Object e)

  Description copied from interface: `NavigableSet`
  Returns the least element in this set strictly greater than the given element, or if there is no such element.

  Specified by:
    `higher` in interface `NavigableSet`
  Parameters:
    `e` - the value to match
  Returns:
    the least element greater than , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null

### pollFirst

    public java.lang.Object pollFirst()

  Description copied from interface: `NavigableSet`
  Retrieves and removes the first (lowest) element, or returns if this set is empty.

  Specified by:
    `pollFirst` in interface `NavigableSet`
  Returns:
    the first element, or if this set is empty

### pollLast

    public java.lang.Object pollLast()

  Description copied from interface: `NavigableSet`
  Retrieves and removes the last (highest) element, or returns if this set is empty.

  Specified by:
    `pollLast` in interface `NavigableSet`
  Returns:
    the last element, or if this set is empty

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedSet`

### first

    public java.lang.Object first()

  Specified by:
    `first` in interface `java.util.SortedSet`
  Throws:
    `NoSuchElementException`

### last

    public java.lang.Object last()

  Specified by:
    `last` in interface `java.util.SortedSet`
  Throws:
    `NoSuchElementException`

### subSet

    public NavigableSet subSet(java.lang.Object fromElement,
                               boolean fromInclusive,
                               java.lang.Object toElement,
                               boolean toInclusive)

  Description copied from interface: `NavigableSet`
  Returns a view of the portion of this set whose elements range from to . If and are equal, the returned set is empty unless and are both true. The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Specified by:
    `subSet` in interface `NavigableSet`
  Parameters:
    `fromElement` - low endpoint of the returned set
    `fromInclusive` - if the low endpoint is to be included in the returned view
    `toElement` - high endpoint of the returned set
    `toInclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements range from , inclusive, to , exclusive
  Throws:
    `java.lang.ClassCastException` - if and cannot be compared to one another using this set's comparator (or, if the set has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if or cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if or is null
    `java.lang.IllegalArgumentException` - if is greater than ; or if this set itself has a restricted range, and or lies outside the bounds of the range.

### headSet

    public NavigableSet headSet(java.lang.Object toElement,
                                boolean inclusive)

  Description copied from interface: `NavigableSet`
  Returns a view of the portion of this set whose elements are less than (or equal to, if is true) . The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Specified by:
    `headSet` in interface `NavigableSet`
  Parameters:
    `toElement` - high endpoint of the returned set
    `inclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements are less than (or equal to, if is true)
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this set's comparator (or, if the set has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException` - if this set itself has a restricted range, and lies outside the bounds of the range

### tailSet

    public NavigableSet tailSet(java.lang.Object fromElement,
                                boolean inclusive)

  Description copied from interface: `NavigableSet`
  Returns a view of the portion of this set whose elements are greater than (or equal to, if is true) . The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Specified by:
    `tailSet` in interface `NavigableSet`
  Parameters:
    `fromElement` - low endpoint of the returned set
    `inclusive` - if the low endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements are greater than or equal to
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this set's comparator (or, if the set has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException` - if this set itself has a restricted range, and lies outside the bounds of the range

### subSet

    public java.util.SortedSet subSet(java.lang.Object fromElement,
                                      java.lang.Object toElement)

  Description copied from interface: `NavigableSet`

  Equivalent to .

  Specified by:
    `subSet` in interface `NavigableSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if or is null
    `java.lang.IllegalArgumentException`

### headSet

    public java.util.SortedSet headSet(java.lang.Object toElement)

  Description copied from interface: `NavigableSet`

  Equivalent to .

  Specified by:
    `headSet` in interface `NavigableSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException`

### tailSet

    public java.util.SortedSet tailSet(java.lang.Object fromElement)

  Description copied from interface: `NavigableSet`

  Equivalent to .

  Specified by:
    `tailSet` in interface `NavigableSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException`

### descendingSet

    public NavigableSet descendingSet()

  Returns a reverse order view of the elements contained in this set. The descending set is backed by this set, so changes to the set are reflected in the descending set, and vice-versa.

  The returned set has an ordering equivalent to ``Collections.reverseOrder`(comparator())`. The expression returns a view of essentially equivalent to .

  Specified by:
    `descendingSet` in interface `NavigableSet`
  Returns:
    a reverse order view of this set

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD